<?xml version="1.0" encoding="UTF-8"?>
<project name="zoph" default="full-build">
 <property name="pdepend" value="${basedir}/vendor/bin/pdepend"/>
 <property name="phpcpd"  value="${basedir}/vendor/bin/phpcpd"/>
 <property name="phpcs"   value="${basedir}/vendor/bin/phpcs"/>
 <property name="phpdox"  value="${basedir}/vendor/bin/phpdox"/>
 <property name="phploc"  value="${basedir}/vendor/bin/phploc"/>
 <property name="phpmd"   value="${basedir}/vendor/bin/phpmd"/>
 <property name="phpunit" value="${basedir}/vendor/bin/phpunit"/> 
 <target name="full-build" depends="prepare,composer,static-analysis,phpunit,phpdox,-check-failure" description="Performs static analysis, runs the tests, and generates project documentation"/>

 <target name="full-build-parallel" depends="prepare,static-analysis-parallel,phpunit,phpdox,-check-failure" description="Performs static analysis (executing the tools in parallel), runs the tests, and generates project documentation"/>

 <target name="static-analysis" depends="lint,phpstan,phploc,pdepend,phpmd,phpcs,phpcpd" description="Performs static analysis"/>

 <!-- Adjust the threadCount attribute's value to the number of CPUs -->
 <target name="static-analysis-parallel" description="Performs static analysis (executing the tools in parallel)">
  <parallel threadCount="2">
   <sequential>
    <antcall target="pdepend"/>
    <antcall target="phpmd"/>
   </sequential>
   <antcall target="lint"/>
   <antcall target="phpstan"/>
   <antcall target="phpcpd"/>
   <antcall target="phpcs"/>
   <antcall target="phploc"/>
  </parallel>
 </target>

 <target name="clean" unless="clean.done" description="Cleanup build artifacts">
  <delete dir="${basedir}/build/api"/>
  <delete dir="${basedir}/build/coverage"/>
  <delete dir="${basedir}/build/logs"/>
  <delete dir="${basedir}/build/pdepend"/>
  <delete dir="${basedir}/build/phpdox"/>
  <delete dir="${basedir}/.images"/>
  <property name="clean.done" value="true"/>
 </target>

 <target name="prepare" unless="prepare.done" depends="clean" description="Prepare for build">
  <mkdir dir="${basedir}/build/api"/>
  <mkdir dir="${basedir}/build/coverage"/>
  <mkdir dir="${basedir}/build/logs"/>
  <mkdir dir="${basedir}/build/pdepend"/>
  <mkdir dir="${basedir}/build/phpdox"/>
  <touch file="${basedir}/build/logs/phpstan.xml" mkdirs="true" verbose="true"/>
  <property name="prepare.done" value="true"/>
  <exec executable="${basedir}/UnitTests/createTestData/runTest.php" taskname="createTestImages" />
 </target>
 <target name="composer" unless="composer.done" depends="prepare" description="Install compser dependencies">
  <exec executable="composer" taskname="composer">
   <arg value="install"/>
  </exec>
  <property name="composer.done" value="true"/>
 </target>
 <target name="lint" unless="lint.done" description="Perform syntax check of sourcecode files">
  <apply executable="php" taskname="lint">
   <arg value="-l"/>

   <fileset dir="${basedir}/php">
    <include name="**/*.php"/>
    <modified/>
   </fileset>

   <fileset dir="${basedir}/UnitTests">
    <include name="**/*.php"/>
    <modified/>
   </fileset>
  </apply>

  <property name="lint.done" value="true"/>
 </target>
 <target name="phpstan" unless="phpstan.done" description="Perform syntax check of sourcecode files">
  <exec executable="${basedir}/vendor/bin/phpstan" taskname="phpstan" output="${basedir}/build/logs/phpstan.xml">
   <arg value="--no-interaction"/>
   <arg value="--no-progress"/>
   <arg value="--error-format=checkstyle"/>
   <arg value="-c"/>
   <arg path="${basedir}/build/phpstan.neon"/>
   <arg value="analyse"/>
   <arg value="php"/>
   <arg value="UnitTests"/>
  </exec>
  <property name="phpstan.done" value="true"/>
 </target>

 <target name="phploc" unless="phploc.done" depends="prepare" description="Measure project size using PHPLOC and log result in CSV and XML format. Intended for usage within a continuous integration environment.">
  <exec executable="${phploc}" taskname="phploc">
   <arg value="--count-tests"/>
   <arg value="--log-csv"/>
   <arg path="${basedir}/build/logs/phploc.csv"/>
   <arg value="--log-xml"/>
   <arg path="${basedir}/build/logs/phploc.xml"/>
   <arg path="${basedir}/php"/>
   <arg path="${basedir}/UnitTests"/>
  </exec>

  <property name="phploc.done" value="true"/>
 </target>

 <target name="pdepend" unless="pdepend.done" depends="prepare" description="Calculate software metrics using PHP_Depend and log result in XML format. Intended for usage within a continuous integration environment.">
  <exec executable="${pdepend}" taskname="pdepend">
   <arg value="--jdepend-xml=${basedir}/build/logs/jdepend.xml"/>
   <arg value="--jdepend-chart=${basedir}/build/pdepend/dependencies.svg"/>
   <arg value="--overview-pyramid=${basedir}/build/pdepend/overview-pyramid.svg"/>
   <arg value="--ignore=${basedir}/php/templates" />
   <arg path="${basedir}/php"/>
  </exec>

  <property name="pdepend.done" value="true"/>
 </target>

 <target name="phpmd" unless="phpmd.done" depends="prepare" description="Perform project mess detection using PHPMD and log result in XML format. Intended for usage within a continuous integration environment.">
  <exec executable="${phpmd}" taskname="phpmd">
   <arg path="${basedir}/php"/>
   <arg value="xml" />
   <arg value="${basedir}/build/phpmd.xml" />
   <arg value="--reportfile"/>
   <arg path="${basedir}/build/logs/pmd.xml"/>
  </exec>

  <property name="phpmd.done" value="true"/>
 </target>

 <target name="phpcs" unless="phpcs.done" depends="prepare" description="Find coding standard violations using PHP_CodeSniffer and log result in XML format. Intended for usage within a continuous integration environment.">
  <exec executable="${phpcs}" output="/dev/null" taskname="phpcs">
   <arg value="--report=checkstyle"/>
   <arg value="--report-file=${basedir}/build/logs/checkstyle.xml"/>
   <arg value="--standard=${basedir}/build/phpcs.xml"/>
   <arg value="--extensions=php"/>
   <arg value="--ignore=autoload.php"/>
   <arg path="${basedir}/php"/>
   <arg path="${basedir}/UnitTests"/>
  </exec>

  <property name="phpcs.done" value="true"/>
 </target>

 <target name="phpcpd" unless="phpcpd.done" depends="prepare" description="Find duplicate code using PHPCPD and log result in XML format. Intended for usage within a continuous integration environment.">
  <exec executable="${phpcpd}" taskname="phpcpd">
   <arg value="--log-pmd"/>
   <arg path="${basedir}/build/logs/pmd-cpd.xml"/>
   <arg path="${basedir}/php"/>
  </exec>

  <property name="phpcpd.done" value="true"/>
 </target>

 <target name="phpunit" unless="phpunit.done" depends="prepare" description="Run unit tests with PHPUnit">
  <exec executable="${phpunit}" resultproperty="result.phpunit" taskname="phpunit">
   <arg value="--configuration"/>
   <arg path="${basedir}/build/phpunit.xml"/>
  </exec>

  <property name="phpunit.done" value="true"/>
 </target>

 <target name="phpdox" unless="phpdox.done" depends="phploc,phpcs,phpmd,phpunit" description="Generate project documentation using phpDox">
  <exec executable="${phpdox}" dir="${basedir}/build" taskname="phpdox"/>

  <property name="phpdox.done" value="true"/>
 </target>

 <target name="-check-failure">
  <fail message="PHPUnit did not finish successfully">
   <condition>
    <not>
     <equals arg1="${result.phpunit}" arg2="0"/>
    </not>
   </condition>
  </fail>
 </target>
</project>
